#define _WIN32_DCOM
#include <iostream.h>
#import "prvocislo.dll" no_namespace

void main()
{
	HRESULT hr;

	cout << "spousti se klient...." << endl;

    hr = CoInitializeEx(NULL, COINIT_APARTMENTTHREADED);
    if(FAILED(hr))
        cout << "Klient:     Nelze inicializovat apartment. " << endl;

	try
	{
		IPrvocislaPtr pPrvo(_uuidof(Prvocisla));

		for (int i=1;i<10;i++)
		{
			cout << i << ". prvocislo je: " << pPrvo->DejPrvocislo(i) << endl;
		}
		
		int n;
		cout << "zadej n: ";
		cin >> n;
		
		if (pPrvo->JePrvocislo(n)) cout << "Je to prvocislo" << endl;
		else cout << "Neni to prvocislo" << endl;
		
		pPrvo = NULL;
	}
	catch(_com_error &err)
	{
		cout << "Nastala chyba: " << err.ErrorMessage() << endl;
	}
    CoUninitialize();
}
