//written by petr paus
#include <iostream>
#include <comdef.h>
#include <direct.h>
#include <string.h>
#include "Prvocisla_h.h"

using namespace std;

void main() 
{
	IUnknown*		pUnknown;
    IPrvocisla*		pPrvo;

    HRESULT hr = S_OK;


    hr = CoInitialize(NULL);
    
	if(FAILED(hr))
        cout << "Nelze inicializovat..." << endl;

	cout << "Volam CoCreateInstance pro Prvocisla." << endl;
    hr = CoCreateInstance(CLSID_Prvocisla , NULL, 
        CLSCTX_INPROC_SERVER, IID_IUnknown, (void**)&pUnknown);
    if(FAILED(hr))
        cout << "Nelze zalozit instanci komponenty. " << endl;

	cout << "Volam QueryInterface na IPrvocisla." << endl;
    hr = pUnknown->QueryInterface(IID_IPrvocisla, (void**)&pPrvo);
    if(FAILED(hr))
        cout << "Komponenta nepodporuje rozhrani IPrvocisla. " << endl;

	cout << "Uvolnuji IUnknown.\n\n" << endl;
    pUnknown->Release();

    //*******************************************************************************
	
	int cislo;

	for (int i=1;i<10;i++)
	{
		pPrvo->DejPrvocislo(i,&cislo);
		cout << i << ". prvocislo je: " << cislo << endl;
	}
	
	int n;
	cout << "zadej n: ";
	cin >> n;
	
	int ano;

	pPrvo->JePrvocislo(n,&ano);

	if (ano) cout << "Je to prvocislo" << endl;
	else cout << "Neni to prvocislo" << endl;
		

    cout << "\n\nUninitialize" << endl;
	CoUninitialize();
}